suffix_dl_link = "-WIN-x64-installer.exe"


def update_package():
    print("Update package content from upstream binary sources")
    from waptpackage import PackageEntry
    import requests, re

    # Update transition from BeautifulSoup 3 to 4
    try:
        import bs4 as BeautifulSoup
    except:
        import BeautifulSoup

    # Getting proxy informations from WAPT settings
    proxy = {}
    if isfile(makepath(application_data(), "waptconsole", "waptconsole.ini")):
        proxywapt = inifile_readstring(
            makepath(user_local_appdata(), "waptconsole", "waptconsole.ini"),
            "global",
            "http_proxy",
        )
        if proxywapt:
            proxy = {"http": proxywapt, "https": proxywapt}

    # Specific app values
    app_name = control.name
    url = control.sources

    # Get latest version number from official website
    page = requests.get(
        url + "/latest",
        headers={"User-Agent": "Mozilla/5.0 (Windows NT 6.1; Win64; x64)"},
    ).text
    bs = BeautifulSoup.BeautifulSoup(page)
    bs_raw_string = str(bs.find("span", {"class": "css-truncate-target"}).text)
    version = bs_raw_string

    print("Latest " + app_name + " version is: " + version)

    # https://github.com/FreeCAD/FreeCAD/releases/download/0.18.2/FreeCAD-0.18.16117.dbb4cc6-WIN-x64-installer.exe

    # Declaring binaries extension to download
    reg_bin = "%s$" % suffix_dl_link  # $ mean the end of regex chain
    end_bin = re.compile(reg_bin)

    links = bs.findAll("a", {"href": end_bin})
    part_url_dl = links[0]["href"]
    # print(part_url_dl)

    url_dl = "https://github.com" + part_url_dl
    print("Download url is: " + url_dl)

    latest_bin = bin_name_string % version

    # Downloading latest binaires
    if not isfile(latest_bin):
        print("Downloading " + latest_bin)
        wget(url_dl, latest_bin, proxies=proxy)

        # Change version of the package
        pe = PackageEntry()
        pe.load_control_from_wapt(os.getcwd())

        pe.version = version + "-0"
        pe.save_control_to_wapt(os.getcwd())
        print("Update package done. You can now build-upload your package")
    else:
        print("This package is already up-to-date")

    # Deleting outdated binaries
    for actual_bin in glob.glob(bin_name_joker):
        if actual_bin != latest_bin:
            print(actual_bin + " Deleted")
            remove_file(actual_bin)


if __name__ == "__main__":
    update_package()
