system_local_appdata_x86 = makepath(systemdrive, "Windows", "system32", "config", "systemprofile", "AppData", "Local")
system_local_appdata_x64 = makepath(systemdrive, "Windows", "SysWOW64", "config", "systemprofile", "AppData", "Local")
system_appdata_x86 = makepath(systemdrive, "Windows", "system32", "config", "systemprofile", "AppData", "Roaming")
system_appdata_x64 = makepath(systemdrive, "Windows", "SysWOW64", "config", "systemprofile", "AppData", "Roaming")
required_dirs_x86 = [
    makepath(system_local_appdata_x86, "Temp"),
    makepath(system_local_appdata_x86, "Downloaded Installations"),
]
required_dirs_x64 = [
    makepath(system_local_appdata_x64, "Temp"),
    makepath(system_local_appdata_x64, "Downloaded Installations"),
]
machinesetup_conf_file = "Philips.CIS.MachineSetup.ini"


def install():
    # Define ICCA configuration and generating file
    inifile_writestring(
        makepath(basedir, machinesetup_conf_file),
        "MachineSetup",
        "SystemName",
        my_icca_system_name,
    )
    inifile_writestring(
        makepath(basedir, machinesetup_conf_file),
        "MachineSetup",
        "PrimaryServerName",
        my_icca_server_name,
    )

    # Installing the package
    if running_as_system():
        # If needed, creating required directories in systemprofiles
        for requireddirs in required_dirs_x86:
            if not isdir(requireddirs):
                print("Creating: %s" % requireddirs)
                mkdirs(requireddirs)
        if iswin64():
            for requireddirs in required_dirs_x64:
                if not isdir(requireddirs):
                    print("Creating: %s" % requireddirs)
                    mkdirs(requireddirs)
        run_as_administrator('"%s" %s' % (makepath(basedir, bin_name), silent_install_args))
