> wapt-get --help
 -r --repo : URL of dependencies libs
 waptupgrade : upgrade wapt-get.exe and database
 tasks : check if some tasks are running or pending in queue
 dnsdebug : display some informations about DNS configuration.
 check-licences : display status of licences on the server
 add-licence <filename.lic> : register a licence on the server
 build-waptagent : get waptsetup.exe from server, and stuff it with current configuration (-c parameter).
                   build a waptupgrade package, and upload both to server.
                   the embedded config is named "default" or can be specified with --config-name=<name>
   --config-name=<name>  set the name of the configuration in installer.
 create-keycert [options] :
   --CommonName= common name
   --CommonName64= common name encoded in base64 (if accents, spaces etc...)
   --CodeSigning=0/1 (default: 1)
   --CA=0/1 (default: 1)
   --ClientAuth=0/1 (default: 1)
   --PrivateKeyPassword64=
   --PrivateKeyPassword=
   -NoPrivateKeyPassword
   -F : force overwrite existing
   --Country=
   --Locality=
   --Organization=
   --OrgUnit=
   --Email=
   --CAKeyFilename= (default: default_ca_key_path in waptconsole.ini)
   --CACertFilename= (default: default_ca_cert_path in waptconsole.ini)
   --CAKeyPassword=
   -NoCAKeyPassword : CA key is not encrypted
   --BaseDir= directory where to store created keys and certificates (default: personal_certificate_path directory of waptconsole.ini)
   -EnrollNewCert: copies the certificate to wapt\ssl
   -SetAsDefaultPersonalCert: certificate path is set to personal_certificate_path of waptconsole.ini
 add-config-from-url <url>   : append a dynamic json config to conf.d, extract trusted certificates.
   --json-config-name=<name>  overwrite the name of configuration.
   --json-config-priority=<number>  specify configuration order. lower priorities are overwritten by higher priorities.
 reset-config-from-url <url> : removes all previous config/certificates and dynamic config and apply json to wapt-get.ini
 set-config-from-url <url>   : overwrite wapt-get.ini with json config, keep dynamic configs

Usage: wapt-get.exe -c configfile action

WAPT install system.

action is either :
  install <package> : install one or several packages by name, directory or wapt file
  update            : update package database
  upgrade           : upgrade installed packages, install host package if not installed.
  remove <package>  : remove installed packages

  download <package>: force download one or several packages
  show <package>    : show attributes of one or more packages

  forget <package>  : removes the installation status of <package> from local Wapt database.

  list [keywords]   : list installed packages containing keywords
  list-upgrade      : list upgradable packages
  check-upgrades    : show last update/upgrade status
  download-upgrade  : download available upgradable packages
  search [keywords] : search installable packages whose description contains keywords
  clean             : remove all WAPT cached files from local drive
  upgradedb         : manually upgrade the schema used by the WAPT database. If the database file can't be found, it will be recreated.

  add-upgrade-shutdown    : add a local shutdown policy to launch upgrade
                            of packages at windows shutdown (via waptexit.exe)
  remove-upgrade-shutdown : remove shutdown policy

  restart-waptservice : restart waptservice

  register [description] : Add the computer to the WAPT server database,
                                     change the description of the computer.
  inventory         : get json encoded list of host data, installed packages and softwares as supplied to server with register
  update-status     : Send packages and softwares status to the WAPT server,

  setlocalpassword  : Set the local admin password for waptservice access to
                      packages install/remove (for standalone usage)

  reset-uuid        : reset host's UUID to the uuid provided by the BIOS.
  generate-uuid     : regenerate a random host's UUID, stored in wapt-get.ini.

  get-server-certificate : get the public key from waptserver and save it to <waptbasedir>\ssl\server
  enable-check-certificate : get the public key from waptserver,save it to <waptbasedir>\ssl\server and enable verify in config file.

  add-config-from-url <filelink> <sha256hashfile> : add a configuration file from url
  add-config-from-file
  add-config-from-base64
  remove-config  <config-name> : remove a json synamic config by its base name.
  list-config
  list-available-config

 For user session setup
  session-setup [packages,ALL] : setup local user environment for specific or all installed packages

 For packages development (Wapt default configuration is taken from user's waptconsole.ini if it exists)
  list-registry [keywords]  : list installed softwares from system registry
  installed-softwares [keywords]  : same behaviour than list-registry
  sources <package>         : checkout or update sources of a package from SVN repository (if attribute Sources was supplied in control file)
  make-template <installer-path> [<packagename> [<source directoryname>]] : initializes a package template with an installer (exe or msi)
  make-host-template <machinename> [[<package>,<package>,...] [directory]] :
                                initializes a package meta template with packages.
                                If no package name is given, use FQDN
  make-group-template <groupname> [[<package>,<package>,...] [directory]] :
                                initializes a meta package template with supplied dependencies.

  build-package <directory> : creates a WAPT package from supplied directory
  sign-package <directory or package>  : add a signature of the manifest using a private SSL key
  build-upload <directory> : creates a WAPT package from supplied directory, sign it and upload it
  duplicate <directory or package> <new-package-name> [<new-version> [<target directory>]] : duplicate an existing package,
                                            changing its name (can be used for duplication of host packages...)
  edit <package> [p1,p2,..]: download and unzip a package. Open in Explorer the target directory. Appends dependencies p1, p2 ...
  edit-host <host fqdn> [p1,p2,..]: download an unzip a host package. Open in Explorer the target directory. Appends dependencies p1, p2 ...

  update-package-sources <directory> : source <directory>/setup.py module and launch the update_package() hook to update binaries and other informations automatically.

 For repository management
  upload-package  <filenames> : upload package to repository (using winscp for example.)
  scan-packages <directory> : rebuild a "Packages" file for http package repository

 For windows updates WaptWUA management (Enterprise only)
   waptwua-scan : scan status of windows against current rules and send result to server
   waptwua-download : scan status of windows against current rules, download missing kb and send result to
   waptwua-install : install pending updates

 For (Enterprise only)
   propose-upgrade : Launch an upgrade proposal by launching waptexit in open sessions

 For initial setup
   create-keycert  : create a RSA key pair and X509 certificate with /CommonName, /CodeSigning and /CA params. Use /PrivateKeyPassword for key encrypt. Store crt and pem into /BaseDir
   build-waptagent : compile a waptagent.exe and waptupgrade package using /ConfigFilename parameter to ini file. By default, use waptconsole configuration.
   stuff-waptsetup ! append a json wapt config file to waptsetup.exe for initial setup.




Options:
  --version             show program's version number and exit
  -h, --help            show this help message and exit
  -c CONFIG, --config=CONFIG
                        Config file full path (default: none)
  -l LOGLEVEL, --loglevel=LOGLEVEL
                        Loglevel (default: warning)
  -D, --direct          Don't use http service for update/upgrade (default:
                        False)
  -S, --service         User http service for update/upgrade/install/remove
                        (default: False)
  -u, --update-packages
                        Update Packages first then action (default: False)
  -f, --force           Force (default: False)
  -p PARAMS, --params=PARAMS
                        Setup params as a JSon Object (example :
                        {'licence':'AZE-567-34','company':'TIS'}} (default:
                        {})
  -r WAPT_URL, --repository=WAPT_URL
                        URL of main wapt repository (override url from ini
                        file, example http://wapt/wapt) (default: )
  -y, --hide            Hide the console (default: False)
  -F FILTER_ON_HOST_CAP, --use-host-caps=FILTER_ON_HOST_CAP
                        Filter the packages based on the current host
                        capabilities (0/1) (default: none)
  -i, --inc-release     Increase release number when building package
                        (default: False)
  -a UPDATE_SERVER_STATUS, --update-server-status=UPDATE_SERVER_STATUS
                        Send updated status of host (soft, packages, etc..) to
                        server after action  (0/1)(default: 1)
  --keep-signature-date
                        Keep the current package signature date, and file
                        changetime (default: False)
  -s SECTION_FILTER, --sections=SECTION_FILTER
                        Add a filter section to search query (default: ALL)
  -o REDIRECT_OUTPUT, --output=REDIRECT_OUTPUT
                        Redirect the outputs to a given file (default: use
                        redirect_stdout_to ini value)
  -j, --json            Switch to json output for scripts purpose (default:
                        False)
  -e ENCODING, --encoding=ENCODING
                        Chararacter encoding for the output (default: no
                        change)
  -x EXCLUDES, --excludes=EXCLUDES
                        Comma separated list of files or directories to
                        exclude for build-package (default: none)
  -k PERSONAL_CERTIFICATE_PATH, --certificate=PERSONAL_CERTIFICATE_PATH
                        Path to the PEM X509 personal certificate to sign
                        packages. Package are unsigned if not provided
                        (default: )
  -w PRIVATE_KEY_PASSWD, --private-key-passwd=PRIVATE_KEY_PASSWD
                        Path to the password of the private key. (default: )
  -U USER, --user=USER  Interactive user (default: no change)
  -g USERGROUPS, --usergroups=USERGROUPS
                        Groups of the final user as a JSon array for checking
                        install permission (default: [])
  -t MAX_TTL, --maxttl=MAX_TTL
                        Max run time in minutes of wapt-get process before
                        being killed by subsequent wapt-get (default: 60
                        minutes)
  -L LANGUAGE, --language=LANGUAGE
                        Override language for install (example : fr) (default:
                        en)
  -m MD, --message-digest=MD
                        Message digest type for signatures.  (default: sha256)
  -n, --newest-only     Return only the newest version of packages when
                        searching. (default: False)
  --locales=LOCALES     Override packages locales filter. (default: None)
  --maturity=MATURITY   Set/change package maturity when building package.
                        (default: None)
  --pin-server-cert     When registering, pin the server certificate.
                        (default: none)
  --wapt-server-url=SET_WAPTSERVER_URL
                        When registering, set wapt-get.ini wapt_server
                        setting. (default: none)
  --wapt-repo-url=SET_WAPTREPO_URL
                        When registering, set wapt-get.ini repo_url setting.
                        (default: none)
  --wapt-server-user=WAPT_SERVER_USER
                        User to upload packages to waptserver. (default: none)
  --wapt-server-passwd=WAPT_SERVER_PASSWD
                        Password to upload packages to waptserver. (default:
                        none)
  --log-to-windows-events
                        Log steps to the Windows event log (default: False)
  --use-gui             Force use of GUI Helper even if not in dev mode.
                        (default: False)
  --no-ide              Don't launch ide when editing a package. (default:
                        False)
  --not-interactive     Disable dialog to ask credential users (for batch
                        mode). (default: False)
  --waptbasedir=WAPT_BASE_DIR
                        Force a different wapt-base-dir then default dir of
                        waptutils.py. (default: none)
  --devmode             Enable devmode. dbpath is set to :memory: and cert/key
                        are in userappdata. (default: False)
  --json-config-name=JSON_CONFIG_NAME
                        The name of the json file given with the action json-
                        config-from-file/base64/url.
  --json-config-priority=JSON_CONFIG_PRIORITY
                        The priority of the json file given with the action
                        json-config-from-file/base64/url.
  --only-priorities=ONLY_PRIORITIES, --only_priorities=ONLY_PRIORITIES
                        Upgrade packages with specific priorities (default:
                        none)
  --only-if-not-process-running, --only_if_not_process_running
                        Upgrade packages only if impacted processes are not
                        running (default: False)

