# -*- coding: utf-8 -*-
from setuphelpers import *
import platform

uninstallkey = []

# Declaring specific app values (TO CHANGE)
bin_name = "TreeSizeFreeSetup.exe"
silent_args = "/VERYSILENT /SUPPRESSMSGBOXES /NORESTART"
uninstall_key = "TreeSize Free_is1"


def install():
    # Specific app values
    package_version = control.version.split("-", 1)[0]

    # Installing the package
    install_exe_if_needed(
        bin_name,
        silentflags=silent_args,
        key=uninstall_key,
        min_version=package_version,
    )


def update_package():
    print("Download/Update package content from upstream binary sources")

    # Getting proxy informations from WAPT settings
    proxy = {}
    if platform.system() == "Windows" and isfile(makepath(user_local_appdata(), "waptconsole", "waptconsole.ini")):
        proxywapt = inifile_readstring(
            makepath(user_local_appdata(), "waptconsole", "waptconsole.ini"),
            "global",
            "http_proxy",
        )
        if proxywapt:
            proxy = {"http": proxywapt, "https": proxywapt}

    # Specific app values
    app_name = control.name
    latest_bin = bin_name
    url_dl = "https://downloads.jam-software.de/treesize_free/TreeSizeFreeSetup.exe"

    print("Download url is: " + url_dl)

    # Downloading latest binaries
    if isfile(latest_bin):
        remove_file(latest_bin)
    if not isfile(latest_bin):
        print("Downloading: " + latest_bin)
        wget(url_dl, latest_bin, proxies=proxy)

        # Get version from file
        version = get_file_properties(latest_bin)["ProductVersion"]

        # Change version of the package
        pe = PackageEntry().load_control_from_wapt(".")
        pe.version = "%s-%s" % (version, int(pe.version.split("-", 1)[1]) + 1)
        pe.save_control_to_wapt(".")
        print("Changing version to " + pe.version + " in WAPT\\control")
        print("Update package done. You can now build-upload your package")
    else:
        print("This package is already up-to-date")
