# -*- coding: utf-8 -*-
from setuphelpers import *
import os

"""   {
   "key":"{57CCBB58-8D11-48E9-AD74-34ABAA1F2A32}",
   "name":"GeoConcept Viewer cdgc/1713-1",
   "version":"7.3.1713",
   "install_date":"",
   "install_location":"C:\\Program Files (x86)\\GeoConcept SA\\GeoConcept Viewer",
   "uninstall_string":"RunDll32 C:\\PROGRA~2\\COMMON~1\\INSTAL~1\\PROFES~1\\RunTime\\0701\\Intel32\\Ctor.dll,LaunchSetup \"C:\\Program Files (x86)\\GeoConcept SA\\GeoConcept Viewer\\Setup\\GeoConcept Viewer\\Setup.exe\" -l0x40c ",
   "publisher":"GeoConcept SA",
   "system_component":0,
   "win64":false
  }
https://www.itninja.com/blog/view/installshield-setup-silent-installation-switches

"""
# app_uninstallkey = "{57CCBB58-8D11-48E9-AD74-34ABAA1F2A32}"
app_name = "GeoConcept Viewer"
editor_dir = makepath(programfiles32, "GeoConcept SA")
app_dir = makepath(editor_dir, "GeoConcept Viewer")
uninstall_response_path = makepath(app_dir, "uninstall.iss")
uninstaller_path = makepath(app_dir, "Setup", "GeoConcept Viewer", "Setup.exe")


def install():
    bin_name = "GeoConcept_Viewer.exe"
    log_file_path = makepath(systemdrive, "Windows", "Temp", bin_name + ".log")
    uninstall_log_file_path = makepath(systemdrive, "Windows", "Temp", bin_name + "_uninstall.log")
    response_log_file_path = makepath(systemdrive, "Windows", "Temp", bin_name + "_response.log")  # not usable

    # # Getting install.iss
    # response_path = makepath(basedir, "install.iss")
    # run(f'"{bin_name}" /r /f1"{response_path}"', timeout=1200)

    # Installing the software
    install_response_path = makepath(basedir, "install.iss")
    install_exe_if_needed(
        bin_name,
        silentflags=f'/s /f1"{install_response_path}" /f2"{log_file_path}"',
        # key=app_uninstallkey,
        name="GeoConcept Viewer",
        min_version=control.get_software_version(),
        timeout=1200,
    )
    app_uninstallkey = installed_softwares(name=app_name)[0]["key"]

    # # Getting uninstall.iss
    # response_path = makepath(basedir, "uninstall.iss")
    # run(f'"{uninstaller_path}" /r /f1"{response_path}"', timeout=1200)

    # Copying uninstall.iss
    filecopyto("uninstall.iss", uninstall_response_path)

    # Adding QuietUninstallString
    quiet_uninstall_string = f'"{uninstaller_path}" /s /f1"{uninstall_response_path}" /f2"{uninstall_log_file_path}"'
    register_uninstall(app_uninstallkey, quiet_uninstall_string=quiet_uninstall_string)


def uninstall():
    # Uninstalling the software
    for to_uninstall in installed_softwares(app_name):
        print("Removing: %s (%s)" % (to_uninstall["name"], to_uninstall["version"]))
        killalltasks(ensure_list(control.impacted_process))
        run(uninstall_cmd(to_uninstall["key"]))
        wait_uninstallkey_absent(to_uninstall["key"])

    # It will not work as is
    for to_uninstall in installed_softwares(name=app_name, ignore_empty_names=False):
        print("Removing empty key: %s" % to_uninstall["key"])
        unregister_uninstall(to_uninstall["key"])

    if isdir(app_dir):
        remove_tree(app_dir)
    if remove_empty_directories(editor_dir):
        remove_tree(editor_dir)


def remove_empty_directories(root_directory):
    if os.path.exists(root_directory):
        for dirpath, dirnames, filenames in os.walk(root_directory, topdown=False):
            if not any(os.scandir(dirpath)):
                os.rmdir(dirpath)
                print(f"Removed empty directory: {dirpath}")
