def install():
    source_dir = makepath(basedir, dir_name)
    response_json_path = makepath(basedir, "Response.json")
    if isdir(temp_dir):
        remove_tree(temp_dir)
    shutil.move(source_dir, temp_dir)

    bin_path = makepath(temp_dir, bin_name)
    if isfile(bin_path):
        install_exe_if_needed(
            bin_path,
            silentflags="--nocache --wait --noUpdateInstaller --noWeb --quiet --norestart",
            name=app_name,
            min_version=control.get_software_version(),
            timeout=2500,
            # time_wait_uninstallkey_present=5000,
        )
        # Adding QuietUninstallStrings and uninstallkeys for WAPT
        app_uninstallkey = installed_softwares(name=app_name)[0]["key"]
        quiet_uninstall_string = installed_softwares(uninstallkey=app_uninstallkey)[0]["uninstall_string"] + " --quiet --norestart"
        register_uninstall(app_uninstallkey, quiet_uninstall_string=quiet_uninstall_string)
        if not app_uninstallkey in uninstallkey:
            uninstallkey.append(app_uninstallkey)

    else:
        uninstallkey.append(installed_softwares(name=app_name)[0]["key"])

    # Uninstallkey list
    additional_app = installed_softwares(name="vs_CoreEditorFonts")
    if additional_app:
        uninstallkey.append(additional_app[0]["key"])
    additional_app = installed_softwares(name="Microsoft Visual Studio Installer")
    if additional_app:
        uninstallkey.append(additional_app[0]["key"])
