#!waptpython
# -*- coding: utf-8 -*-
import os
import sys

sys.path.insert(0, os.path.dirname(os.path.realpath(__file__)))
from setupdevhelpers import *
from dev_utils import *

sys.path.insert(0, sys.executable.rsplit(os.path.sep, 1)[0].replace("/bin", "").replace("\\Scripts", ""))
from setuphelpers import *


###############################################################################

# check if a value as been passed to the script
package_root_dir = params.get("package_root_dir")
if not package_root_dir:
    package_root_dir = ask_directory()


# get package tool path
package_tools_path = get_package_tools_path()
pkg_dir_list = get_individual_packages(package_root_dir)
newer_control_file = get_newer_file(pkg_dir_list, control_makepath, os_based=False)
newer_icon_file = get_newer_file(pkg_dir_list, icon_makepath, os_based=False)
control_file_sha256 = get_file_sha256(newer_control_file)
icon_sha256 = get_file_sha256(newer_icon_file)
new_control_dict = get_control_dict(newer_control_file)
# list of value to be updated from new dict to all control files

control_values_to_update = [
    "package",
    "name",
    "version",
    "description",
    "categories",
    "maintainer",
    "sources",
    "description_fr",
    "description_pl",
    "description_de",
    "description_es",
    "description_pt",
    "description_it",
    "description_ru",
    "description_nl",
    "editor",
    "keywords",
    "licence",
    "homepage",
]

# update all pkg_dir_list with new control values
for pkg_dir in pkg_dir_list:
    current_control_sha256 = get_file_sha256(control_makepath(pkg_dir))
    if current_control_sha256 != control_file_sha256:
        print("Updating: %s" % pkg_dir)
        control_path = makepath(pkg_dir, "WAPT", "control")
        control_dict = get_control_dict(control_path)
        updated_values = update_values(control_dict, new_control_dict, control_values_to_update)
        update_control(control_path, updated_values)

# unify icons
if newer_icon_file:
    for pkg_dir in pkg_dir_list:
        icon_path = makepath(pkg_dir, "WAPT", "icon.png")
        current_icon_sha256 = get_file_sha256(icon_path)
        if current_icon_sha256 != icon_sha256:
            print(f"Updating: {pkg_dir} with {newer_icon_file}")
            filecopyto(newer_icon_file, icon_path)
        else:
            print(f"package already up to date skipping for {pkg_dir}")


# list of value to be removed from all control files

# clean all pkg_dir_list
for pkg_dir in pkg_dir_list:
    print("Cleaning: %s" % pkg_dir)
    control_path = makepath(pkg_dir, "WAPT", "control")
    control_dict = get_control_dict(control_path)
    clean_dict = clean_control_dict(control_dict)
    update_control(control_path, clean_dict)
